//
//  FileDownloadViewController.m
//  FileDownload
//
//  Created by Brad Larson on 3/14/2010.
//

#import "FileDownloadViewController.h"

@implementation FileDownloadViewController

#pragma mark -
#pragma mark Initialization and teardown

- (void)viewDidLoad 
{
    [super viewDidLoad];
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark -
#pragma mark Download methods

- (IBAction)downloadFile;
{
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
	
	NSString *locationOfRemoteFile = urlTextField.text;	
	NSURLRequest *theRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:locationOfRemoteFile] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:60.0];
	downloadConnection = [[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	if (downloadConnection) 
	{
		downloadedFileContents = [[NSMutableData data] retain];
	} 
	else 
	{
	}
}

- (void)downloadCompleted;
{
	[downloadConnection release];
	downloadConnection = nil;
	
	[downloadedFileContents release];
	downloadedFileContents = nil;
	
	[downloadFileName release];
	downloadFileName = nil;

//	downloadStatus.hidden = YES;
//	downloadProgressView.hidden = YES;
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
}


#pragma mark -
#pragma mark URL connection delegate methods

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error;
{
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Download failed" message:@"Could not download file"
												   delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
	[alert show];
	[alert release];
	
	[self downloadCompleted];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data;
{
	//http://movies.apple.com/datapub/us/podcasts/apple_keynotes/ipad.m4v
	[downloadedFileContents appendData:data];
	downloadProgressView.progress = (float)[downloadedFileContents length] / downloadFileSize;
	downloadStatus.text = [NSString stringWithFormat:@"%.2f MB of %.2f MB", (float)[downloadedFileContents length] / 1000000.0, downloadFileSize / 1000000.0];
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response;
{
	downloadFileSize = [response expectedContentLength];
	downloadFileName = [[response suggestedFilename] copy];

	downloadStatus.hidden = NO;
	downloadProgressView.hidden = NO;
	downloadProgressView.progress = 0.0f;
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection;
{
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory = [paths objectAtIndex:0];
	
	NSError *error = nil;
	if (![downloadedFileContents writeToFile:[documentsDirectory stringByAppendingPathComponent:downloadFileName] options:NSAtomicWrite error:&error])
	{
		// TODO: Do some error handling here
		return;
	}
		
	[self downloadCompleted];	
}



@end
